import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Mover here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mover  extends Actor
{
    private GreenfootSound nommy = new GreenfootSound("nommy.wav");
    private static int PACDOT_POINTS = 10;
    private static int POWERPELLET_POINTS = 50;
    private static int GHOST_POINTS = 200;
    private static int CHERRY_POINTS = 100;
    /**
     * Act - do whatever the Mover wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }
    
    public boolean atWorldEdge()
    {
        if(getX() > getWorld().getWidth() - 2 || getX() == 0)
            return true;
        if(getY() > getWorld().getHeight() - 2 || getY() == 0)
            return true;
        else
            return false;
    }
    
    public boolean canMove(String direction) {
        int x;
        int y;
        if(direction == "right") {
            x = getX()+1;
            y = getY();
        } else if(direction == "left") {
            x = getX()-1;
            y = getY();
        } else if(direction == "up") {
            x = getX();
            y = getY()-1;
        } else {
            x = getX();
            y = getY()+1;
        }
        int origX = getX();
        int origY = getY();
        setLocation(x,y);
        Actor theWall = getOneIntersectingObject(Wall.class);
        Actor theGate = getOneIntersectingObject(Gate.class);
        setLocation(origX, origY);
        
        return(theWall == null && (theGate == null || direction != "down"));}
    
    public boolean isOn(Class clss) {
        Actor actor = getOneIntersectingObject(clss);
        if(actor != null & clss == Ghost.class && ((Ghost) actor).isDead) return false;
        return actor != null;
    }
    
    public void eat(Class clss) {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        Pacworld world = (Pacworld) getWorld();
        Counter counter = world.getCounter();
        Counter counterLives = world.getLives();
        if(actor != null && clss != Pacman.class && clss != Ghost.class && clss != Cherry.class) {
            world.removeObject(actor);
        }
        if (clss == Pacdot.class) {
            counter.bumpCount(PACDOT_POINTS);
        } else if (clss == Powerpellet.class) {
            counter.bumpCount(POWERPELLET_POINTS);
            world.canEatGhosts = true;
            world.ghostTimer = 0;
        } else if (clss == Ghost.class) {
            List ghosts = world.getObjectsAt(getX(), getY(), Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.die();
                counter.bumpCount(GHOST_POINTS);
                nommy.play();
                showPoints(GHOST_POINTS, getX(), getY());
            }
        } else if (clss == Pacman.class) {
            if(world.numLives < 2) {
                world.endGame();
            } else {
                world.decLives();
            }
        } else if (clss == Cherry.class) {
            List cherries = world.getObjectsAt(getX(), getY(), Cherry.class);
            for(int i = 0;i<cherries.size();i++) {
                Cherry cherry = (Cherry) cherries.get(i);
                cherry.goBack();
                counter.bumpCount(CHERRY_POINTS);
                nommy.play();
                showPoints(CHERRY_POINTS, getX(), getY());
            }
        }
    }
    
    public void showPoints(int points, int x, int y) {
        Pacworld world = (Pacworld) getWorld();
        Counter showPoints = new Counter(points, true);
        world.addObject(showPoints, x, y);
        Greenfoot.delay(25);
        world.removeObject(showPoints);
    }
}
